Name:           bluej-extensions
Summary:        Various extensions for bluej
Version:        20140825
Release:        %mkrel 4
License:        MIT, EPL and BlueJ, ASM, LGPLv2, GPLv2+
Url:            http://www.bluej.org/extensions/extensions.html
Group:          Development/Java
BuildArch:      noarch
BuildRequires:  unzip
BuildRequires:  tar
Requires:       bluej
%define         extension_dir %{_datadir}/bluej/extensions/
Source0:        %{name}-%{version}.tar.bz2
Source1:        extension_list.txt
Source2:        update_extensions.sh
Requires:       %{name}-multiproject
Requires:       %{name}-rolesofvariables
Requires:       %{name}-cnu-formatter
Requires:       %{name}-acm-invoker
Requires:       %{name}-checkstyle
Requires:       %{name}-patterncoder

%description
BlueJ offers an extension API that allows third parties to develop extensions
to the environment. Extensions offer additional functionality not included in
the core system.

#----------------------------------------------------------------------

%package multiproject
Summary:        A Multi-Project Workspace Handler
Group:          Development/Java
License:        MIT
Requires:       %{name} = %{version}
Requires:       bluej
Url:            http://multiproject.sourceforge.net

%description multiproject
This BlueJ extension allows you to easily manage (i.e. create, import/export
and switch between) multiple BlueJ projects. Some neat features help you to
auto-position package windows or to handle bunches of jar files economically
(e.g. when correcting students' exercises).

%files multiproject
%doc multiproject.pdf
%{extension_dir}/multiproject.jar

#----------------------------------------------------------------------

%package rolesofvariables
Summary:        Identifying the roles of variables
Group:          Development/Java
License:        MIT
Requires:       %{name} = %{version}
Requires:       bluej
Url:            http://www.bluej.org/extensions/files/rolesOfVariables.zip

%description rolesofvariables
The Roles of Variables BlueJ extension is based on Sajaniemi's Roles of
Variables theory, which describes the common ways in which variables are used
in programming. The extension allows users to annotate their programs with
labels based on these roles, and uses an automated system to check whether the
actual use of the variable is consistent with that role assignment.

%files rolesofvariables
%doc RoV_training_files.zip rolesOfVariables-README.txt BishopDissertation.pdf koliPaper.pdf
%{extension_dir}/roles_of_variables.jar
%dir %{extension_dir}/RoVs
%dir %{extension_dir}/RoVs_Javadocs
%{extension_dir}/RoVs/*
%{extension_dir}/RoVs_Javadocs/*

#----------------------------------------------------------------------

%package cnu-formatter
Summary:        CNU BlueJ Code Formatter
Group:          Development/Java
License:        EPL and BlueJ
Requires:       %{name} = %{version}
Requires:       bluej
Url:            http://cnubluej.pcs.cnu.edu/CNUBlueJFormatterInstaller25x.jar

%description cnu-formatter
CNU BlueJ formatter is a BlueJ extension that integrates Eclipse's code style
formatting capabilities into BlueJ's editor. The formatter adds a "Format"
button to the editor, and formats compiled source code according to a set of
style properties specified in a properties file. These properties can be
customized using a simple dialog interface accessible from BlueJ's Preferences
option. For convenience, the formatter comes with an installation executable
JAR file.

%files cnu-formatter
%{extension_dir}/CNUBlueJFormatterInstaller25x.jar

#----------------------------------------------------------------------

%package acm-invoker
Summary:        ACM Invoker
Group:          Development/Java
License:        ACM
Requires:       %{name} = %{version}
Requires:       bluej
Url:            http://www.bluej.org/extensions/ACMInvoker/ACMInvoker.jar

%description acm-invoker
An extension to make it easier to work with the ACM Java Task Force library.

If any class in a BlueJ class diagram implements the acm.program.Program class,
this extension adds a menu item to the class which will create an object, place
it on the BlueJ object bench and invoke its start() method. I.e. "run" it
inside BlueJ rather than as an external Applet.

%files acm-invoker
%doc ACMInvokerLicense.pdf
%{extension_dir}/ACMInvoker.jar

#----------------------------------------------------------------------

%package checkstyle
Summary:        Checking of coding styles
Group:          Development/Java
License:        LGPLv2
Requires:       %{name} = %{version}
Requires:       bluej
Url:            http://bluejcheckstyle.sourceforge.net

%description checkstyle
Allows automated checking of coding styles. Coding styles can be specified
flexibly in an external file. This is a major update to this extension,
including:

 * Now uses the latest Checkstyle release, v4.3
 * Simpler one-jar installation
 * Allows configuration files to be read from URLs in addition to local files
 * The documentation has additional tips useful for lab-based or cloned setup

%files checkstyle
%{extension_dir}/checkstyle-extension-4.3-0.jar

#----------------------------------------------------------------------

%package patterncoder
Summary:        A Design Patterns Extension
Group:          Development/Java
License:        GPLv2+
Requires:       %{name} = %{version}
Requires:       bluej
Url:            http://www.patterncoder.org

%description patterncoder
Provides a wizard which guides the user through the process of adding a Design
Pattern or binary class relationship to a BlueJ project. The user can select a
pattern or relationship and choose specific names for the component classes. A
set of basic classes are then generated. The classes have sufficient code
out-of-the-box to allow exploration of the behaviour with no additional coding.

They can then be edited to meet the requirements of specific problems. A
selection of patterns and relationships is provided, and other patterns can be
defined using XML files and added into the extension.

%files patterncoder
%doc guide.pdf
%{extension_dir}/PatternCoder.jar
%{extension_dir}/PatternFiles
%{extension_dir}/javadoc
%{extension_dir}/src

#----------------------------------------------------------------------

%prep
%setup -q
for file in *.zip ; do
   unzip $file
   rm $file
done
for file in *.tar.gz ; do
   tar -xf $file
   rm $file
done
#
mv patterncoder_0.5.3/* .
rmdir patterncoder_0.5.3
#
mv rolesOfVariables/* .
find . -name .DS_Store -delete
find . -name *~ -delete
find . -name .project -delete
find . -name .classpath -delete
rmdir rolesOfVariables
mv README.txt rolesOfVariables-README.txt
chmod -x *.zip

%build
# nothing

%install
export NO_BRP_CHECK_BYTECODE_VERSION=true
mkdir -p %{buildroot}/%{extension_dir}
cp -r * %{buildroot}/%{extension_dir}/
# cleanup the mess
rm -rf %{buildroot}/%{extension_dir}/__MACOSX*
# documentation
install -m644 %{SOURCE1} .
install -m644 %{SOURCE2} .
for file in  RoV_training_files.zip rolesOfVariables-README.txt *.pdf ; do
   find %{buildroot}/%{extension_dir}/ -name "$file" -exec mv -v {} . \;
done
mv %{buildroot}/%{extension_dir}/papers/*.pdf .
rmdir %{buildroot}/%{extension_dir}/papers

%files
%dir %{_datadir}/bluej
%doc extension_list.txt update_extensions.sh
%dir %{extension_dir}


%changelog
* Thu Feb 04 2016 umeabot <umeabot> 20140825-4.mga6
+ Revision: 935028
- Mageia 6 Mass Rebuild

* Wed Oct 15 2014 umeabot <umeabot> 20140825-3.mga5
+ Revision: 742967
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 20140825-2.mga5
+ Revision: 678183
- Mageia 5 Mass Rebuild

* Sun Aug 31 2014 alexl <alexl> 20140825-1.mga5
+ Revision: 670050
- imported package bluej-extensions

