#!/bin/bash
DO_ECHO=""
WORKDIR=$(pwd)
DATE=$(date +"%Y%m%d")
DOWNLOAD_DIR="$WORKDIR/bluej-extensions-$DATE"
I=1;

mkdir -p "$DOWNLOAD_DIR"
TMPFILE1=$(mktemp /tmp/update_bluej_extensions-XXXXXX)
TMPFILE2=$(mktemp /tmp/update_bluej_extensions-XXXXXX)

function generate_spec(){
	local NAME="$1"
	local FILENAME="$2"
	local NO="$3"
	case "$FILENAME" in
		*.jar*)
		    echo "Suggests:       %{name}-$NAME" >> $TMPFILE1
		;;
		*.pdf)
			# do nothing
		;;
		*.zip)
            echo "Suggests:       %{name}-$NAME" >> $TMPFILE1
		;;
		*.tar.gz)
            echo "Suggests:       %{name}-$NAME" >> $TMPFILE1
		;;
		*)
			echo "Suggests:       %{name}-$NAME" >> $TMPFILE1
	esac
}

echo "%setup -q -T -c %{name} " > $TMPFILE2
pushd "$DOWNLOAD_DIR" >/dev/null
# download files
while read a b c; do
	case $a in 
	\#*|'')
		# ignore
	;;
	*)
		I=$((I+1))
		echo "Updating: $a"
		$DO_ECHO wget -qc $b -O $c
		generate_spec "$a" "$c" "$I"
	;;
	esac
done < "$WORKDIR/"extension_list.txt

popd >/dev/null
I=0
cat $TMPFILE1
echo
cat $TMPFILE2
echo
rm $TMPFILE1
rm $TMPFILE2
test -f "bluej-extensions-$DATE.tar.bz2" && rm -f "bluej-extensions-$DATE.tar.bz2"
tar -cjf "bluej-extensions-$DATE.tar.bz2" "bluej-extensions-$DATE"

sed -i "s|^Version:.*|Version:        $DATE|" bluej-extensions.spec
sed -i "s|bluej-extensions-.*.tar.bz2|bluej-extensions-$DATE.tar.bz2|" bluej-extensions.spec
